<template lang="pug">
ui-input-autocomplete(
	:label="label"
	v-model="model"
	:options="searchItems"
	multiple
	@onSearch="onSearch"
	required
	:rules="rules"
)
	template(#no-option)
		q-item
			q-item-section.text-grey Тех карты не найдены
	template(#selected-item="{props}")
		q-chip(
			removable
			outline
			@remove="props.removeAtIndex(props.index)"
			:tabindex="props.tabindex"
			color="grey"
		)
			q-avatar(v-for="tmi in props.opt.techMapItems" :key="tmi.ingredient.visual.id")
				img(:src="tmi.ingredient.visual.lowUrl")
			span {{ props.opt.name }}


</template>

<script lang="ts">
	import { computed, defineComponent, reactive, ref } from 'vue'
	import { ITechMap, FilterOptionsQuery } from '@/plugins/utils/types'
	import UiInputAutocomplete from '@/components/ui/UiInputAutocomplete.vue'
	import UiTooltip from '@/components/ui/UiTooltip.vue'
	import { client } from '@/plugins/api'

	export default defineComponent({
		name: 'CollectionTechMaps',

		components: {
			UiInputAutocomplete,
			UiTooltip,
		},

		props: {
			modelValue: {
				type: Array,
				default: () => [],
			},
			max: {
				type: Number,
				default: Infinity,
			},
			label: {
				type: String,
				default: 'Технологические карты',
			},
			rules: {
				type: Array,
				default: () => [],
			},
		},

		emits: ['update:modelValue'],

		setup(props, { emit }) {
			const model = computed<ITechMap[]>({
				get: (): ITechMap[] => {
					return props.modelValue as ITechMap[]
				},
				set: (val) => {
					emit('update:modelValue', val)
				},
			})

			const isMaxCount = computed(() => model.value.length >= props.max)

			const addDialogModel = ref(false)

			const searchItems = ref([])

			return {
				val: ref(null),

				model,
				addDialogModel,
				searchItems,
				isMaxCount,
				async onSearch(search: string, update: any) {
					const values = await client.techmaps.getAll(
						new FilterOptionsQuery({
							size: 50,
							search,
						}),
					)
					update(() => {
						searchItems.value = values.items
					})
				},
			}
		},
	})
</script>

<style lang="scss" scoped>
	.my-card {
		width: 100%;
		max-width: 222px;
	}
</style>
